FastDatePrinter (Apache Commons Lang 3.20.0 API)
Description: declaration: package: org.apache.commons.lang3.time, class: FastDatePrinter

# Class FastDatePrinter

java.lang.Object
org.apache.commons.lang3.time.FastDatePrinter

All Implemented Interfaces:
  `Serializable, DatePrinter`

public class FastDatePrinter extends Object implements DatePrinter, Serializable
FastDatePrinter is a fast and thread-safe version of `SimpleDateFormat`.

To obtain a FastDatePrinter, use `FastDateFormat.getInstance(String, TimeZone, Locale)` or another variation of the factory methods of `FastDateFormat`.

Since FastDatePrinter is thread safe, you can use a static member instance:

`private static final DatePrinter DATE_PRINTER = FastDateFormat.getInstance("yyyy-MM-dd");`

This class can be used as a direct replacement to `SimpleDateFormat` in most formatting situations. This class is especially useful in multi-threaded server environments. `SimpleDateFormat` is not thread-safe in any JDK version, nor will it be as Sun have closed the bug/RFE.

Only formatting is supported by this class, but all patterns are compatible with SimpleDateFormat (except time zones and some year patterns - see below).

Java 1.4 introduced a new pattern letter, `'Z'`, to represent time zones in RFC822 format (for example, `+0800` or `-1100`). This pattern letter can be used here (on all JDK versions).

In addition, the pattern `'ZZ'` has been made to represent ISO 8601 extended format time zones (for example, `+08:00` or `-11:00`). This introduces a minor incompatibility with Java 1.4, but at a gain of useful functionality.

Starting with JDK7, ISO 8601 support was added using the pattern `'X'`. To maintain compatibility, `'ZZ'` will continue to be supported, but using one of the `'X'` formats is recommended.

Javadoc cites for the year pattern: For formatting, if the number of pattern letters is 2, the year is truncated to 2 digits; otherwise it is interpreted as a number. Starting with Java 1.7 a pattern of 'Y' or 'YYY' will be formatted as '2003', while it was '03' in former Java versions. FastDatePrinter implements the behavior of Java 7.

Since:
  3.2
See Also:
  - `FastDateParser`
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `FULL`
  FULL locale dependent date or time style.
  `static final int`
  `LONG`
  LONG locale dependent date or time style.
  `static final int`
  `MEDIUM`
  MEDIUM locale dependent date or time style.
  `static final int`
  `SHORT`
  SHORT locale dependent date or time style.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `FastDatePrinter(String pattern, TimeZone timeZone, Locale locale)`
  Constructs a new FastDatePrinter.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected StringBuffer`
  `applyRules(Calendar calendar, StringBuffer buf)`
  Deprecated.
  Use `format(Calendar)` or `format(Calendar, Appendable)`
  `boolean`
  `equals(Object obj)`
  Compares two objects for equality.
  `String`
  `format(long millis)`
  Formats a millisecond `long` value.
  `<B extends Appendable>
  B`
  `format(long millis, B buf)`
  Formats a millisecond `long` value into the supplied `Appendable`.
  `StringBuffer`
  `format(long millis, StringBuffer buf)`
  Formats a millisecond `long` value into the supplied `StringBuffer`.
  `StringBuffer`
  `format(Object obj, StringBuffer toAppendTo, FieldPosition pos)`
  Deprecated.
  Use {`format(Date)`, {`format(Calendar)`, {`format(long)`.
  `String`
  `format(Calendar calendar)`
  Formats a `Calendar` object.
  `<B extends Appendable>
  B`
  `format(Calendar calendar, B buf)`
  Formats a `Calendar` object into the supplied `Appendable`.
  `StringBuffer`
  `format(Calendar calendar, StringBuffer buf)`
  Formats a `Calendar` object into the supplied `StringBuffer`.
  `String`
  `format(Date date)`
  Formats a `Date` object using a `GregorianCalendar`.
  `<B extends Appendable>
  B`
  `format(Date date, B buf)`
  Formats a `Date` object into the supplied `Appendable` using a `GregorianCalendar`.
  `StringBuffer`
  `format(Date date, StringBuffer buf)`
  Formats a `Date` object into the supplied `StringBuffer` using a `GregorianCalendar`.
  `Locale`
  `getLocale()`
  Gets the locale used by this printer.
  `int`
  `getMaxLengthEstimate()`
  Gets an estimate for the maximum string length that the formatter will produce.
  `String`
  `getPattern()`
  Gets the pattern used by this printer.
  `TimeZone`
  `getTimeZone()`
  Gets the time zone used by this printer.
  `int`
  `hashCode()`
  Returns a hash code compatible with equals.
  `protected List<org.apache.commons.lang3.time.FastDatePrinter.Rule>`
  `parsePattern()`
  Returns a list of Rules given a pattern.
  `protected String`
  `parseToken(String pattern, int[] indexRef)`
  Performs the parsing of tokens.
  `protected org.apache.commons.lang3.time.FastDatePrinter.NumberRule`
  `selectNumberRule(int field, int padding)`
  Gets an appropriate rule for the padding required.
  `String`
  `toString()`
  Gets a debugging string version of this formatter.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### FULL

    public static final int FULL
    FULL locale dependent date or time style.
    See Also:
      - Constant Field Values

  - ### LONG

    public static final int LONG
    LONG locale dependent date or time style.
    See Also:
      - Constant Field Values

  - ### MEDIUM

    public static final int MEDIUM
    MEDIUM locale dependent date or time style.
    See Also:
      - Constant Field Values

  - ### SHORT

    public static final int SHORT
    SHORT locale dependent date or time style.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### FastDatePrinter

    protected FastDatePrinter(String pattern, TimeZone timeZone, Locale locale)
    Constructs a new FastDatePrinter. Use `FastDateFormat.getInstance(String, TimeZone, Locale)` or another variation of the factory methods of `FastDateFormat` to get a cached FastDatePrinter instance.
    Parameters:
      `pattern` - `SimpleDateFormat` compatible pattern.
      `timeZone` - non-null time zone to use.
      `locale` - non-null locale to use.
    Throws:
      `NullPointerException` - if pattern, timeZone, or locale is null.

- ## Method Details

  - ### applyRules

    @Deprecated protected StringBuffer applyRules(Calendar calendar, StringBuffer buf)
    Deprecated.
    Use `format(Calendar)` or `format(Calendar, Appendable)`
    Performs the formatting by applying the rules to the specified calendar.
    Parameters:
      `calendar` - the calendar to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### equals

    public boolean equals(Object obj)
    Compares two objects for equality.
    Overrides:
      `equals` in class `Object`
    Parameters:
      `obj` - the object to compare to.
    Returns:
      `true` if equal.

  - ### format

    public String format(Calendar calendar)
    Description copied from interface: `DatePrinter`
    Formats a `Calendar` object. The TimeZone set on the Calendar is only used to adjust the time offset. The TimeZone specified during the construction of the Parser will determine the TimeZone used in the formatted string.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `calendar` - the calendar to format.
    Returns:
      the formatted string.

  - ### format

    public <B extends Appendable> B format(Calendar calendar, B buf)
    Description copied from interface: `DatePrinter`
    Formats a `Calendar` object into the supplied `Appendable`. The TimeZone set on the Calendar is only used to adjust the time offset. The TimeZone specified during the construction of the Parser will determine the TimeZone used in the formatted string.
    Specified by:
      `format` in interface `DatePrinter`
    Type Parameters:
      `B` - the Appendable class type, usually StringBuilder or StringBuffer.
    Parameters:
      `calendar` - the calendar to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### format

    public StringBuffer format(Calendar calendar, StringBuffer buf)
    Description copied from interface: `DatePrinter`
    Formats a `Calendar` object into the supplied `StringBuffer`. The TimeZone set on the Calendar is only used to adjust the time offset. The TimeZone specified during the construction of the Parser will determine the TimeZone used in the formatted string.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `calendar` - the calendar to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### format

    public String format(Date date)
    Description copied from interface: `DatePrinter`
    Formats a `Date` object using a `GregorianCalendar`.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `date` - the date to format
    Returns:
      the formatted string

  - ### format

    public <B extends Appendable> B format(Date date, B buf)
    Description copied from interface: `DatePrinter`
    Formats a `Date` object into the supplied `Appendable` using a `GregorianCalendar`.
    Specified by:
      `format` in interface `DatePrinter`
    Type Parameters:
      `B` - the Appendable class type, usually StringBuilder or StringBuffer.
    Parameters:
      `date` - the date to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### format

    public StringBuffer format(Date date, StringBuffer buf)
    Description copied from interface: `DatePrinter`
    Formats a `Date` object into the supplied `StringBuffer` using a `GregorianCalendar`.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `date` - the date to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### format

    public String format(long millis)
    Description copied from interface: `DatePrinter`
    Formats a millisecond `long` value.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `millis` - the millisecond value to format.
    Returns:
      the formatted string.

  - ### format

    public <B extends Appendable> B format(long millis, B buf)
    Description copied from interface: `DatePrinter`
    Formats a millisecond `long` value into the supplied `Appendable`.
    Specified by:
      `format` in interface `DatePrinter`
    Type Parameters:
      `B` - the Appendable class type, usually StringBuilder or StringBuffer.
    Parameters:
      `millis` - the millisecond value to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### format

    public StringBuffer format(long millis, StringBuffer buf)
    Description copied from interface: `DatePrinter`
    Formats a millisecond `long` value into the supplied `StringBuffer`.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `millis` - the millisecond value to format.
      `buf` - the buffer to format into.
    Returns:
      the specified string buffer.

  - ### format

    @Deprecated public StringBuffer format(Object obj, StringBuffer toAppendTo, FieldPosition pos)
    Deprecated.
    Use {`format(Date)`, {`format(Calendar)`, {`format(long)`.
    Formats a `Date`, `Calendar` or `Long` (milliseconds) object.
    Specified by:
      `format` in interface `DatePrinter`
    Parameters:
      `obj` - the object to format.
      `toAppendTo` - the buffer to append to.
      `pos` - the position; ignored.
    Returns:
      the buffer passed in.
    See Also:
      - `DateFormat.format(Object, StringBuffer, FieldPosition)`

  - ### getLocale

    public Locale getLocale()
    Description copied from interface: `DatePrinter`
    Gets the locale used by this printer.
    Specified by:
      `getLocale` in interface `DatePrinter`
    Returns:
      the locale.

  - ### getMaxLengthEstimate

    public int getMaxLengthEstimate()
    Gets an estimate for the maximum string length that the formatter will produce.

    The actual formatted length will almost always be less than or equal to this amount.

    Returns:
      the maximum formatted length.

  - ### getPattern

    public String getPattern()
    Description copied from interface: `DatePrinter`
    Gets the pattern used by this printer.
    Specified by:
      `getPattern` in interface `DatePrinter`
    Returns:
      the pattern, `SimpleDateFormat` compatible.

  - ### getTimeZone

    public TimeZone getTimeZone()
    Description copied from interface: `DatePrinter`
    Gets the time zone used by this printer.

    This zone is always used for `Date` printing.

    Specified by:
      `getTimeZone` in interface `DatePrinter`
    Returns:
      the time zone.

  - ### hashCode

    public int hashCode()
    Returns a hash code compatible with equals.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      a hash code compatible with equals.

  - ### parsePattern

    protected List<org.apache.commons.lang3.time.FastDatePrinter.Rule> parsePattern()
    Returns a list of Rules given a pattern.
    Returns:
      a `List` of Rule objects.
    Throws:
      `IllegalArgumentException` - if pattern is invalid.

  - ### parseToken

    protected String parseToken(String pattern, int[] indexRef)
    Performs the parsing of tokens.
    Parameters:
      `pattern` - the pattern.
      `indexRef` - index references.
    Returns:
      parsed token.

  - ### selectNumberRule

    protected org.apache.commons.lang3.time.FastDatePrinter.NumberRule selectNumberRule(int field, int padding)
    Gets an appropriate rule for the padding required.
    Parameters:
      `field` - the field to get a rule for.
      `padding` - the padding required.
    Returns:
      a new rule with the correct padding.

  - ### toString

    public String toString()
    Gets a debugging string version of this formatter.
    Overrides:
      `toString` in class `Object`
    Returns:
      a debugging string.